﻿using System.Runtime.InteropServices;

namespace ConsoleApp1
{
    internal class Program
    {
        private readonly static byte[] x86GetSP =
        {
            0x8b, 0xc4,  // mov eax,esp  
            0x83, 0xc0, 0x04, // add eax, 4
            0xc3,   // ret
        };

        private readonly static byte[] x64GetSP =
        {
            0x48, 0x8b, 0xc4, // mov rax, rsp
            0x48, 0x83, 0xc0, 0x08, // add rax, 8
            0xc3,   // ret
        };

        [Flags()]
        private enum AllocationType : uint
        {
            COMMIT = 0x1000,
            RESERVE = 0x2000,
        }

        [Flags()]
        public enum MemoryProtection : uint
        {
            EXECUTE_READWRITE = 0x40,
        }

        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern IntPtr VirtualAlloc(IntPtr lpAddress, UIntPtr dwSize, AllocationType flAllocationType,
            MemoryProtection flProtect);

        [DllImport("kernel32")]
        private static extern bool VirtualFree(IntPtr lpAddress, UInt32 dwSize, UInt32 dwFreeType);

        static unsafe void Main(string[] args)
        {
            IntPtr _codePointer;

            byte[] codeBytes = x86GetSP;

            if (IntPtr.Size == 8)
            {
                codeBytes = x64GetSP;
            }

            _codePointer = VirtualAlloc(IntPtr.Zero, new UIntPtr((uint)codeBytes.Length),
                AllocationType.COMMIT | AllocationType.RESERVE,
                MemoryProtection.EXECUTE_READWRITE
            );

            Marshal.Copy(codeBytes, 0, _codePointer, codeBytes.Length);

            if (IntPtr.Size == 4)
            {
                delegate*<int> getSP = (delegate*<int>)_codePointer;
                int addressByFunc = getSP();
                Console.WriteLine($"0x{addressByFunc:x}");
            }
            else
            {
                delegate*<long> getSP = (delegate*<long>)_codePointer;
                long addressByFunc = getSP();
                Console.WriteLine($"0x{addressByFunc:x16}");
            }

            if (_codePointer != IntPtr.Zero)
            {
                VirtualFree(_codePointer, 0, 0x8000);
                _codePointer = IntPtr.Zero;
            }
        }
    }
}